import lang.stride.*;
import java.util.*;
import greenfoot.*;

public class Button extends UIStuff
{
    protected String shortcut; // draufklicken oder dieses Tastenkürzel
    protected String name; // zur Unterscheidung der Buttons
    protected GreenfootImage gfiNormalState, gfiHoverState, gfiDisabledState;
    public Button(String name, String shortcut, String filename, String filenameHover, String filenameDisabled) {
        this.name = name;
        this.shortcut = shortcut;
        this.gfiNormalState = new GreenfootImage(filename);
        this.setImage(this.gfiNormalState);
        this.gfiHoverState = new GreenfootImage(filenameHover);
        if(filenameDisabled != null) {
            this.gfiDisabledState = new GreenfootImage(filenameDisabled);  
        }
        switch(this.name) {
            case "ton":
                if(Sound.soundIsOn) {
                    this.setImage(this.gfiNormalState);
                } else {
                    this.setImage(this.gfiDisabledState);
                }
                break;
        }
    }

    public void act()
    {
        String k = Greenfoot.getKey();

        if((k != null && k.equals(this.shortcut)) || Greenfoot.mousePressed(this)) {
            this.setImage(this.gfiHoverState);
            Greenfoot.delay(8);
            this.setImage(this.gfiNormalState);
            this.action();
        }
    }

    protected void action() {
        Mars m = (Mars)this.getWorld();

        switch(this.name) {
            case "run":
                m.initializeWorld();
                m.getPeetie().runOrganize();
                break;
            case "ton":
                if(Sound.soundIsOn) {
                    this.setImage(this.gfiDisabledState);
                    Sound.stopAll();
                } else {
                    this.setImage(this.gfiNormalState);
                }
                Sound.play("NO");
                Sound.toggleSoundIsOn();
                Sound.play("NO");
                break;
            case "help":
                m.alleShowTextTexteLoeschen();
                Label anleitung = new Label();
                GreenfootImage a = new GreenfootImage(anleitung.anleitungstext(), 20, Color.WHITE, Color.BLUE);
                anleitung.setImage(a);
                m.addObject(anleitung, m.getWidth()/2, m.getHeight()/2);
                break;
            default:
                break;
        }
    }

    public void setName(String name) {
        this.name = name;
    }
}

